#include "gplayer.h"
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <string.h>

static int suffix_ok(char *name);

gint image_num=0;
void f_cre()
{
  DIR *dir;
  struct dirent *ent;
  gchar *path,cur[300];
  gint num,i=0;
  GdkPixmap *pixmap[15];
  GdkBitmap *bitmap[15];
  gchar *name[15],*push_num=NULL;
  GtkAdjustment *adj;

  path=gtk_ftree_get_selected_path(GTK_FTREE(ftree));

  if(path==NULL) 
    {  
      gtk_progress_set_value(GTK_PROGRESS(prog),0);
      gtk_gcanvas_clear(GTK_GCANVAS(gcanvas));
      longjmp(jmp,1);
      return;
    }

  if((dir=opendir(path))==NULL) 
    {
      gtk_progress_set_value(GTK_PROGRESS(prog),0);
      gtk_gcanvas_clear(GTK_GCANVAS(gcanvas)); 
      
      g_free(path);
      longjmp(jmp,1);
      return;
    }

  getcwd(cur,300);
  chdir(path);
  image_num=0;
  while((ent=readdir(dir))!=NULL)
    {
      if(suffix_ok(ent->d_name))
	image_num++;
    }

  push_num=g_strdup_printf("ե : %d  ",image_num);
  gtk_statusbar_pop(GTK_STATUSBAR(status),status_id);
  status_id=gtk_statusbar_push(GTK_STATUSBAR(status),status_id,push_num);
  g_free(push_num);  

  if(image_num==0)
    {
      gtk_progress_set_value(GTK_PROGRESS(prog),0);
      gtk_gcanvas_clear(GTK_GCANVAS(gcanvas)); 

      chdir(cur);
      g_free(path);
      closedir(dir);
      longjmp(jmp,1);
      return;
    }

  gtk_gcanvas_clear(GTK_GCANVAS(gcanvas));
  num=scroll->allocation.width/100;

  if(num>1)  
    num--;

  gtk_gcanvas_resize(GTK_GCANVAS(gcanvas),num);
  
  adj=(GtkAdjustment*)gtk_adjustment_new(0,0,image_num,1,1,1);
  gtk_progress_set_adjustment(GTK_PROGRESS(prog),adj);  
  
  image_num=0;

  rewinddir(dir);

  while((ent=readdir(dir))!=NULL)
    {
      if(suffix_ok(ent->d_name))
	{
	  GdkImlibImage *pix,*bup;
	  GdkPixmap *pm;
	  GdkBitmap *bm;
	  gint w,h;

	  image_num++;

	  pix=gdk_imlib_load_image(ent->d_name);
	  if(pix==NULL) continue;

	  w=pix->rgb_width,h=pix->rgb_height;

	  
	  if(w>100||h>100)
	    {
	      double x;
	      x=(double)100/w;
	      if((int)(x*h)<=100)
		{
		  w=100;
		  h*=x;
		}
	      else 
		{
		  x=(double)100/h;
		  w*=x;
		  h=100;
		}
	    }


	  gdk_imlib_render(pix,w,h);
	  pm=gdk_imlib_copy_image(pix);
	  bm=gdk_imlib_copy_mask(pix);

	  pixmap[i]=pm;
	  bitmap[i]=bm;
	  name[i]=ent->d_name;

	  if(pix) gdk_imlib_destroy_image(pix);

	  if(i==num-1) 
	    {	   
	      gtk_progress_set_value(GTK_PROGRESS(prog),image_num);
	      gtk_gcanvas_append(GTK_GCANVAS(gcanvas),pixmap,bitmap,name);

	      for(i=0;i<num;i++)
		{
		  if(pixmap[i]!=NULL) gdk_imlib_free_pixmap(pixmap[i]);
		  if(bitmap[i]!=NULL) gdk_imlib_free_bitmap(bitmap[i]);
		}

	      i=-1;
	    }
	  i++;
	}
    }

  if(i!=0) 
    {
      gint j=i;
      for(;j<num;j++)
	{
	  pixmap[j]=NULL;
	  bitmap[j]=NULL;
	  name[j]=NULL;
	}

      gtk_progress_set_value(GTK_PROGRESS(prog),image_num);      
      gtk_gcanvas_append(GTK_GCANVAS(gcanvas),pixmap,bitmap,name);

      for(j=0;j<i;j++)
	{
	  if(pixmap[j]) gdk_imlib_free_pixmap(pixmap[j]);
	  if(bitmap[j]) gdk_imlib_free_bitmap(bitmap[j]);
	}
    }
  chdir(cur);
  closedir(dir);
  g_free(path);
  longjmp(jmp,1);
}

static int suffix_ok(char *name)
{
  gint i,j;
  gint s_num=strlen(name);
  GList *list=gplayer.list;

  for(i=s_num-1;i>0&&name[i]!='.';i--);
  if(i==0) return 0;


  for(;list;list=list->next)
    {

      if(strcmp(&name[i],(gchar*)list->data)==0)
	{ 
	  return 1;
	}    
    }
  return 0;
}
