#include "gplayer.h"
#include <string.h>
#include "gicon.h"

#define BUFF 1024

static GtkWidget* create_pixmap(gchar **xpm_file);
static void sig();

GtkWidget *window,*status;
GtkWidget *ftree,*gcanvas=NULL;
GtkWidget *prog,*scroll;
guint status_id;
jmp_buf jmp;
Gplayer gplayer={2,0,0,0,0,"gimp",NULL,200};

gchar *ini_dir=NULL;
int size_width=730,size_heigth=600;

void g_init()
{
  FILE *fp;
  gchar *file;
  char buff[BUFF];
  GList *tt;
  gchar *def[8]={
    "initial directry:", /* 2---current , 1---home , 0---last*/
    "window size:",
    "hide directory:",
    "full screen:",
    "image time:",
    "application:",
    "show suffix:",
    "paned size:"
  };

  file=g_strconcat(getenv("HOME"),"/.gplayer",NULL);

  fp=fopen(file,"r");

  if(fp==NULL)
    {
      int i;
      fp=fopen(file,"w");
      fprintf(fp,"%s 2\n",def[0]);      
      for(i=1;i<3;i++)
	fprintf(fp,"%s 0\n",def[i]);

      fprintf(fp,"%s 5\n",def[4]);
      fprintf(fp,"%s gimp\n",def[5]);
      fprintf(fp,"%s '.xpm','.gif','.jpeg','.bmp','.jpg','.tiff'\n",def[6]);
      fprintf(fp,"%s 200\n",def[7]);
      fclose(fp);
      fp=fopen(file,"r");
    }
  g_free(file);


  while(fgets(buff,BUFF,fp))
    {
    int i,j,tmp,len,co;
    gchar *suf;

    if(strncmp(buff,def[0],len=strlen(def[0]))==0)
      {
	tmp=atoi(&buff[len]);
	if(0<=tmp&&tmp<=2)
	  gplayer.dir=tmp;
	for(i=len+1;buff[i]!=':';i++);
	for(i++;buff[i]==' ';i++);
	if(buff[i]!='\n')
	  ini_dir=g_strdup(&buff[i]);
	ini_dir[strlen(ini_dir)-1]=0;
      }
    else if(strncmp(buff,def[1],len=strlen(def[1]))==0)
      {
	tmp=atoi(&buff[len]);
	if(tmp==FALSE)
	  gplayer.size=tmp;
	else if(tmp==TRUE)
	  {
	    gplayer.size=tmp;
	    for(i=len+1;buff[i]!=':';i++);
	    for(i++;buff[i]==' ';i++);
	    size_width=atoi(&buff[i]);
	    for(i++;buff[i]!='*';i++);
	    size_heigth=atoi(&buff[++i]);
	  }
      }
    else if(strncmp(buff,def[2],len=strlen(def[2]))==0)
      {
	tmp=atoi(&buff[len]);
	if(tmp==FALSE||tmp==TRUE)
	  gplayer.hide=tmp;
      }
    else if(strncmp(buff,def[3],len=strlen(def[3]))==0) 
      {
	tmp=atoi(&buff[len]);
	if(tmp==FALSE||tmp==TRUE)
	  gplayer.full=tmp;
      }
    else if(strncmp(buff,def[4],len=strlen(def[4]))==0)
      {
	tmp=atoi(&buff[len]);
	if(0<=tmp&&tmp<=120)
	  gplayer.time=tmp;
      }
    else if(strncmp(buff,def[5],len=strlen(def[5]))==0)
      {
	for(i=len;buff[i]==' ';i++);
	gplayer.application=g_strndup(&buff[i],strlen(&buff[i])-1);
      }
    else if(strncmp(buff,def[6],len=strlen(def[6]))==0) 
      {
	gplayer.list=NULL;
	for(i=len;buff[i]!='\0'&&buff[i]==' ';i++);
	
	if(buff[i]!='\'')break;
	
	while(1)
	  {
	    for(;buff[i]!='\0'&&buff[i]!='\'';i++);
	    
	    if(buff[i]=='\0')break;
	    
	    co=++i;
	    for(;buff[i]!='\0'&&buff[i]!='\'';i++);
	    if(buff[i]=='\0')break;
	    
	    suf=(char*)g_malloc(i-co+1);
	    strncpy(suf,&buff[co],i-co);
	    suf[i-co]='\0';
	    gplayer.list=g_list_append(gplayer.list,(gpointer)suf);
	    for(++i;buff[i]!='\0'&&buff[i]==' ';i++);
	    if(buff[i]!=',')break;
	  }
      }
    else if(strncmp(buff,def[7],len=strlen(def[7]))==0)
      {
	tmp=atoi(&buff[len]);
	if(0<tmp&&tmp<gdk_screen_width())
	  gplayer.paned=tmp;
      }  
  }

  fclose(fp);
}

static void sig()
{
  gtk_signal_connect_after(GTK_OBJECT(window),"size_allocate",
			   GTK_SIGNAL_FUNC(f_cre),NULL);
}

void g_create()
{
  GtkWidget *vbox,*paned;
  GtkWidget *toolbar,*view;
  GtkItemFactory *factory;
  GtkWidget *tsc;
  GtkAccelGroup *accel;
  GtkWidget *hbox;
  gchar *name;
  gint i;

  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_border_width(GTK_CONTAINER(window),3);
  gtk_signal_connect(GTK_OBJECT(window),"destroy",
		     GTK_SIGNAL_FUNC(my_quit),NULL);
  gtk_window_set_default_size(GTK_WINDOW(window),size_width,size_heigth);

  gtk_window_set_title(GTK_WINDOW(window),"Graphic Player");

  vbox=gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(window),vbox);

  accel=gtk_accel_group_new();
  factory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<main>",accel);
  gtk_item_factory_create_items(factory,sizeof(menu)/sizeof(menu[0]),
				menu,NULL);
  gtk_accel_group_attach(accel,GTK_OBJECT(window));

  gtk_box_pack_start(GTK_BOX(vbox),gtk_item_factory_get_widget(factory,
							       "<main>"),
		     FALSE,FALSE,0);
  
  toolbar=gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL,GTK_TOOLBAR_ICONS);
  view=gtk_viewport_new(NULL,NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(view),GTK_SHADOW_OUT);
  gtk_box_pack_start(GTK_BOX(vbox),view,FALSE,FALSE,0);
  gtk_container_add(GTK_CONTAINER(view),toolbar);
  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"",NULL,
			      create_pixmap(test_xpm),g_open,NULL);

  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"",NULL,
			      create_pixmap(delete_xpm),g_delete,NULL);
  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"ץѥƥ",NULL,
			  create_pixmap(document_xpm),g_propaty,NULL);
  gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));

  gtk_toolbar_append_item(GTK_TOOLBAR(toolbar),NULL,"饤ɥ硼",NULL,
			  create_pixmap(video_xpm),g_start,NULL);

  paned=gtk_hpaned_new();
  gtk_box_pack_start(GTK_BOX(vbox),paned,TRUE,TRUE,0);

  tsc=gtk_scrolled_window_new(NULL,NULL);
  ftree=gtk_ftree_new();
  if(gplayer.dir==0)
    {
      if(ini_dir)
	{
	gtk_ftree_open(GTK_FTREE(ftree),ini_dir);
	g_free(ini_dir);
	}
    }
  else if(gplayer.dir==1)
    {
      gtk_ftree_open(GTK_FTREE(ftree),getenv("HOME"));
    }
  else if(gplayer.dir==2)
    {
	gtk_ftree_open(GTK_FTREE(ftree),GTK_FTREE(ftree)->current_path);
    }

  if(gplayer.hide==TRUE)
    gtk_ftree_all_map(GTK_FTREE(ftree));
  
  
  gtk_paned_add1(GTK_PANED(paned),tsc);
  gtk_container_add(GTK_CONTAINER(tsc),ftree);

  gtk_signal_connect_after(GTK_OBJECT(window),"map_event",
			   GTK_SIGNAL_FUNC(f_cre),NULL);
  gtk_signal_connect(GTK_OBJECT(window),"map_event",
			   GTK_SIGNAL_FUNC(sig),NULL);

  gtk_signal_connect_after(GTK_OBJECT(ftree),"tree_select_row",
		     GTK_SIGNAL_FUNC(f_cre),NULL);

  gtk_widget_set_usize(ftree,gplayer.paned,-1);

  scroll=gtk_scrolled_window_new(NULL,NULL);
  gtk_paned_add2(GTK_PANED(paned),scroll);
  gcanvas=gtk_gcanvas_new(1);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll),gcanvas);



  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,TRUE,2);

  prog=gtk_progress_bar_new();
  gtk_box_pack_end(GTK_BOX(hbox),prog,FALSE,FALSE,10);
  gtk_widget_set_usize(prog,180,-1);

  status=gtk_statusbar_new();
  gtk_box_pack_end(GTK_BOX(hbox),status,FALSE,FALSE,2);
  status_id=gtk_statusbar_get_context_id(GTK_STATUSBAR(status),"main");
  gtk_widget_set_usize(status,150,-1);

  gtk_widget_show_all(window);


}

static GtkWidget* create_pixmap(gchar **xpm_file)
{
  GdkPixmap *pixmap;
  GdkBitmap *bitmap;
  GtkWidget *widget;

  pixmap= 
    gdk_pixmap_colormap_create_from_xpm_d(NULL,gdk_colormap_get_system (),
                                          &bitmap,
                                          NULL,xpm_file);
  widget=gtk_pixmap_new(pixmap,bitmap);
  
  gdk_pixmap_unref(pixmap);
  gdk_bitmap_unref(bitmap);
  return widget;
}

void my_quit()
{
  save_data();
  exit(0);
}

main(int argc,char *argv[])
{
  gtk_set_locale();
  gtk_init(&argc,&argv);
  gdk_imlib_init();

  g_init();
  g_create();
  setjmp(jmp);
  gtk_main();

}
