#ifndef __GTK_GCANVAS_H__
#define __GTK_GCANVAS_H__


#include <gtk/gtk.h>
#include "gtkgimage.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_GCANVAS			(gtk_gcanvas_get_type ())
#define GTK_GCANVAS(obj)			(GTK_CHECK_CAST ((obj), GTK_TYPE_GCANVAS, GtkGcanvas))
#define GTK_GCANVAS_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_GCANVAS, GtkGcanvasClass))
#define GTK_IS_GCANVAS(obj)		(GTK_CHECK_TYPE ((obj), GTK_TYPE_GCANVAS))
#define GTK_IS_GCANVAS_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_GCANVAS))
#define GTK_GCANVAS_ROW(list)         ((GtkGcanvasRow*)(list->data))

typedef struct _GtkGcanvas       GtkGcanvas;
typedef struct _GtkGcanvasClass  GtkGcanvasClass;
  //typedef struct _GtkGcanvasRow    GtkGcanvasRow;
  //typedef struct _GtkGcanvasData   GtkGcanvasData;

struct _GtkGcanvas
{
  GtkTable table;

  gint column;
  gint row;

  GList *list_row;
  GList *list_selected;
};

struct _GtkGcanvasClass
{
  GtkTableClass        parent_class;
  
};


GtkType gtk_gcanvas_get_type(void);
GtkWidget* gtk_gcanvas_new(gint column);
void gtk_gcanvas_resize(GtkGcanvas *gcanvas,gint column); /* ̤ */
void gtk_gcanvas_append(GtkGcanvas *gcanvas,GdkPixmap **pixmap,
			GdkBitmap **bitmap,gchar **name);
void gtk_gcanvas_set_row(GtkGcanvas *gcanvas,gint row,GdkPixmap **pixmap,
			GdkBitmap **bitmap, gchar **name);
void gtk_gcanvas_set(GtkGcanvas *gcanvas,gint row,gint column,
		     GdkPixmap *pixmap,GdkBitmap *bitmap,gchar *name);
void gtk_gcanvas_remove_node(GtkGcanvas *gcanvas,gint row,gint column);
void gtk_gcanvas_remove_last_row(GtkGcanvas *gcanvas);
void gtk_gcanvas_all_select(GtkGcanvas *gcanvas);
void gtk_gcanvas_clear(GtkGcanvas *gcanvas);
#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_GCANVAS_H__ */
