#ifndef __GTK_GIMAGE_H__
#define __GTK_GIMAGE_H__


#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define GTK_TYPE_GIMAGE			(gtk_gimage_get_type ())
#define GTK_GIMAGE(obj)			(GTK_CHECK_CAST ((obj), GTK_TYPE_GIMAGE, GtkGimage))
#define GTK_GIMAGE_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_GIMAGE, GtkGimageClass))
#define GTK_IS_GIMAGE(obj)		(GTK_CHECK_TYPE ((obj), GTK_TYPE_GIMAGE))
#define GTK_IS_GIMAGE_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_GIMAGE))

enum {
  GIMAGE_NORMAL,
  GIMAGE_ACTIVE,
  GIMAGE_SELECTED,
  GIMAGE_INSENTIVE
};


typedef struct _GtkGimage       GtkGimage;
typedef struct _GtkGimageClass  GtkGimageClass;


struct _GtkGimage
{
  GtkBin bin;

  GtkWidget *table;
  GtkWidget *pixmap;
  GtkWidget *label;

  guint state:2;

};

struct _GtkGimageClass
{
  GtkBinClass        parent_class;

  void (*double_clicked)  (GtkGimage *gimage);
  void (*normal_pressed)  (GtkGimage *gimage);  
  void (*control_pressed) (GtkGimage *gimage);  
};


GtkType        gtk_gimage_get_type       (void);
GtkWidget*     gtk_gimage_new            (GdkPixmap *pix,GdkBitmap *bit,const gchar *label);
void           gtk_gimage_double_clicked        (GtkGimage *gimage);
void           gtk_gimage_normal_pressed        (GtkGimage *gimage);
void           gtk_gimage_control_pressed        (GtkGimage *gimage);
void gtk_gimage_set_pixlabel(GtkGimage *gimage,GdkPixmap *pix,
			     GdkBitmap *bit,const gchar *label);
#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_GIMAGE_H__ */
