#include "gplayer.h"

static void delete_ok(GtkWidget *widget,gpointer data);
static void delete_quit(GtkWidget *dialog);
static void delete_cancel(GtkWidget *widget,gpointer data);

void g_open()
{
  GList *list=GTK_GCANVAS(gcanvas)->list_selected;
  gchar *name,*path;

  list=g_list_last(list);

  if(!list) return;

  gtk_label_get(GTK_LABEL(GTK_GIMAGE((GtkWidget*)list->data)->label),&name);
  path=gtk_ftree_get_selected_path(GTK_FTREE(ftree));
  
  name=g_strconcat(path,"/",name,NULL);

  if(!fork())
    {
      execlp(gplayer.application,gplayer.application,name,NULL);
      _exit(1);
    }
  g_free(path);
  g_free(name);
}

void g_delete()
{
  GList *list;
  GtkWidget *dialog,*label,*button,*vbox,*hbox,*sep;

  if(!GTK_GCANVAS(gcanvas)->list_selected) return;
  dialog=gtk_window_new(GTK_WINDOW_DIALOG);
  vbox=gtk_vbox_new(FALSE,0);
  gtk_window_set_title(GTK_WINDOW(dialog),"");
  gtk_container_border_width(GTK_CONTAINER(dialog),5);
  gtk_signal_connect(GTK_OBJECT(dialog),"destroy",
			    GTK_SIGNAL_FUNC(delete_quit),NULL);
  gtk_container_add(GTK_CONTAINER(dialog),vbox);

  label=gtk_label_new("ʲΥեƤǤ");
  gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,2);
  sep=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),sep,FALSE,FALSE,2);

  for(list=GTK_GCANVAS(gcanvas)->list_selected;list;list=list->next)
    {
      gchar *name;

      gtk_label_get(GTK_LABEL(GTK_GIMAGE((GtkWidget*)list->data)->label),
		    &name);
      label=gtk_label_new(name);
      gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,2);
    }    

  sep=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),sep,FALSE,FALSE,2);

  hbox=gtk_hbox_new(FALSE,0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,2);
  button=gtk_button_new_with_label("OK");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,4);
  gtk_signal_connect(GTK_OBJECT(button),"clicked",
		     GTK_SIGNAL_FUNC(delete_ok),dialog);
  button=gtk_button_new_with_label("Cancel");
  gtk_box_pack_start(GTK_BOX(hbox),button,TRUE,TRUE,4);
  gtk_signal_connect(GTK_OBJECT(button),"clicked",
		     GTK_SIGNAL_FUNC(delete_cancel),dialog);
  GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_window_set_policy(GTK_WINDOW(dialog),FALSE,FALSE,FALSE);
  gtk_grab_add(dialog);
  gtk_widget_show_all(dialog);
  gtk_main();
}

static void delete_ok(GtkWidget *widget,gpointer data)
{
  gchar *path=gtk_ftree_get_selected_path(GTK_FTREE(ftree));
  GList *list;
  GtkWidget *dialog=(GtkWidget*)data;

  for(list=GTK_GCANVAS(gcanvas)->list_selected;list;list=list->next)
    {
      gchar *name;

      gtk_label_get(GTK_LABEL(GTK_GIMAGE((GtkWidget*)list->data)->label),
		    &name);
      name=g_strconcat(path,"/",name,NULL);
      remove(name);
      g_free(name);
    }    
  g_free(path);
  gtk_widget_destroy(dialog);
  f_cre();

}

static void delete_cancel(GtkWidget *widget,gpointer data)
{
  GtkWidget *dialog=(GtkWidget*)data;
  gtk_widget_destroy(dialog);
}

static void delete_quit(GtkWidget *dialog)
{
  gtk_grab_remove(dialog);
  gtk_main_quit();
}


void g_rename()
{

}

void g_propaty()
{

}

void g_about()
{
  GtkWidget *dialog,*label;
  GtkWidget *vbox,*button,*sep;
  GtkStyle *style;
  GdkColor col={0,0xffff,0,0};


  dialog=gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(dialog),"");
  gtk_container_border_width(GTK_CONTAINER(dialog),10);
  gtk_signal_connect_object(GTK_OBJECT(dialog),"destroy",
			    GTK_SIGNAL_FUNC(gtk_grab_remove),GTK_OBJECT(dialog));
  //  gtk_widget_set_usize(dialog,250,150);
  gtk_window_set_policy(GTK_WINDOW(dialog),FALSE,FALSE,FALSE);
  vbox=gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(dialog),vbox);

  gdk_color_alloc(gdk_colormap_get_system(),&col);
  style=gtk_widget_get_default_style();
  style=gtk_style_copy(style);
  gdk_font_unref(style->font);
  style->font=gdk_fontset_load("-*-*-bold-r-*--22-*-*-*-*-*-*");
  style->fg[ GTK_STATE_NORMAL]=col;

  label=gtk_label_new("Graphic Player");
  gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,2);
  gtk_widget_set_style(label,style);

  style=gtk_style_copy(style);
  gdk_font_unref(style->font);
  style->font=gdk_fontset_load("-*-*-medium-r-*--16-*-*-*-*-*-*");
  col.red=0,col.blue=0xffff;
  gdk_color_alloc(gdk_colormap_get_system(),&col);
  style->fg[ GTK_STATE_NORMAL]=col;

  label=gtk_label_new("version : 0.0.2");
  gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,3);
  gtk_widget_set_style(label,style);

  label=gtk_label_new("Licence : GPL");
  gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,4);
  label=gtk_label_new("Copyright (C) 2001 ƣ ");
  gtk_box_pack_start(GTK_BOX(vbox),label,FALSE,FALSE,4);

  sep=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(vbox),sep,FALSE,FALSE,4);

  button=gtk_button_new_with_label("Close");
  gtk_box_pack_end(GTK_BOX(vbox),button,FALSE,FALSE,4);
  gtk_signal_connect_object(GTK_OBJECT(button),"clicked",
			    GTK_SIGNAL_FUNC(gtk_widget_destroy),GTK_OBJECT(dialog));
  GTK_WIDGET_SET_FLAGS(button,GTK_CAN_DEFAULT);
  gtk_widget_grab_default(button);
  gtk_widget_show_all(dialog);
  gtk_grab_add(dialog);


}

void g_quit()
{
  gtk_widget_destroy(window);
}
void g_all()
{
  gtk_gcanvas_all_select(GTK_GCANVAS(gcanvas));
}

